## pypy 2.2.1%2Bdfsg

=== pypy/module/cppyy/bench/Makefile ===
all: bench02Dict_reflex.so

ROOTSYS := ${ROOTSYS}

ifeq ($(ROOTSYS),)
  genreflex=genreflex
  cppflags=
else
  genreflex=$(ROOTSYS)/bin/genreflex
  cppflags=-I$(ROOTSYS)/include -L$(ROOTSYS)/lib
endif

PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
  cppflags+=-dynamiclib -single_module -arch x86_64
endif

ifeq ($(shell $(genreflex) --help | grep -- --with-methptrgetter),)
  genreflexflags=
  cppflags2=-O3 -fPIC
else
  genreflexflags=--with-methptrgetter
  cppflags2=-Wno-pmf-conversions -O3 -fPIC
endif


bench02Dict_reflex.so: bench02.h bench02.cxx bench02.xml
	$(genreflex) bench02.h $(genreflexflags) --selection=bench02.xml -I$(ROOTSYS)/include
	g++ -o $@ bench02.cxx bench02_rflx.cpp -I$(ROOTSYS)/include -shared -lReflex -lHistPainter `root-config --libs` $(cppflags) $(cppflags2)

=== debian/rules ===
#!/usr/bin/make -f

PYTHON=python2.7
# Take advantage of PyPy if it's installed
#PYTHON=$(shell command -v pypy > /dev/null && echo pypy || echo python2.7)

# PyPy doesn't harden well, and handles opt and debug itself
BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

export PYPY_USESSION_BASENAME := debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# dh_python2 is used for pypy-sandbox
%:
	dh $@ --with python2,sphinxdoc

override_dh_auto_configure:
	debian/scripts/memory-check.sh

override_dh_auto_build-arch: pypy/goal/pypy-c pypy/goal/pypy-c-sandbox
	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
	# Build cffi modules
	pypy/goal/pypy-c -c 'import _sqlite3, _curses, _tkinter.tklib, syslog'

override_dh_auto_build-indep:
	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

pypy/goal/pypy-%: export TMPDIR = $(CURDIR)/build-tmp
pypy/goal/pypy-%: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
pypy/goal/pypy-%:
	rm -rf $(TMPDIR)
	mkdir $(TMPDIR)
	debian/scripts/translate.sh --python $(PYTHON) $$(echo $@ | grep -q sandbox && echo --sandbox)
	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
	cp $(C_SRC_DIR)/pypy-c $@

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test: export TMPDIR = $(CURDIR)/build-tests-tmp
override_dh_auto_test: export HOME = $(TMPDIR)
override_dh_auto_test:
	rm -rf $(TMPDIR) build-tests
	mkdir $(TMPDIR) build-tests
	# Test failures currently ignored
	PYTHONPATH=. $(PYTHON) -u testrunner/runner.py \
	                       --logfile=build-tests/pytest-A.log \
	                       --config=pypy/pytest-A.cfg \
	                       --root=pypy || true
	TERM=$${TERM:-dumb} $(PYTHON) -u pypy/test_all.py \
	          --pypy=pypy/goal/pypy-c \
	          --resultlog=build-tests/lib-python.log \
	          lib-python || true
	pypy/goal/pypy-c -u pypy/test_all.py \
	       --resultlog=build-tests/pypy-c.log \
	       pypy/module/pypyjit/test_pypy_c || true
endif

override_dh_auto_install:
	# Upstream provides no install script

override_dh_fixperms-indep:
	find debian/pypy-lib debian/pypy-lib-testsuite debian/pypy-tk \
	     -name '*.pyc' -delete
	find debian/pypy-lib debian/pypy-lib-testsuite debian/pypy-tk \
	     -name '__pycache__' -delete
	# Don't need these, and lintian will make a noise about them
	find debian/pypy-lib \( -name 'regen' -o -name '*.bat' -o -name 'fetch_*' \) -delete
	# Remove empty directories, because pypyclean will
	find debian/pypy-lib*/usr/lib/pypy/lib-python -type d -empty -delete
	# Nothing in the stdlib should be executable
	chmod -R a-x+X debian/pypy-lib*/usr/lib/pypy/lib*
	# Fix interpreters
	find debian/pypy-lib debian/pypy-lib-testsuite debian/pypy-tk \
	     -name '*.py' -print0 \
	     | xargs -0 sed -i -e '1s|^#!.*python.*|#!/usr/bin/pypy|'
	dh_fixperms -i

override_dh_sphinxdoc-arch:
	# dh_sphinxdoc doesn't fail silently when there are no docs

override_dh_compress:
	dh_compress -X.inv -X.txt

override_dh_python2:
	dh_python2 -p python-pypy.sandbox

override_dh_installdeb:
	set -e; for maintscript in preinst postinst; do \
		sed 's/#VERSION#/$(VER)/g' debian/pypy.$$maintscript.in \
		    > debian/pypy.$$maintscript; \
	done
	dh_installdeb

override_dh_builddeb:
	dh_builddeb -- -Zxz

HG_REPO ?= https://bitbucket.org/pypy/pypy
REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
get-packaged-orig-source:
	@echo "You can build this from a local repo by supplying the HG_REPO variable"
	rm -rf pypy-$(VER).orig
	hg clone $(HG_REPO) pypy-$(VER).orig
ifeq (,$(REV))
	cd pypy-$(VER).orig && hg up -r release-$(VER)
else
	cd pypy-$(VER).orig && hg up -r $(REV)
endif
	rm -rf pypy-$(VER).orig/.hg*
	rm pypy-$(VER).orig/lib-python/*2.7/distutils/command/*.exe
	tar -cJ --owner root --group root --mode a+rX \
	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
	rm -rf pypy-$(VER).orig

## pypy 2.2.1+dfsg

=== Makefile ===

all: pypy-c

PYPY_EXECUTABLE := $(shell which pypy)
URAM := $(shell python -c "import sys; print 4.5 if sys.maxint>1<<32 else 2.5")

ifeq ($(PYPY_EXECUTABLE),)
RUNINTERP = python
else
RUNINTERP = $(PYPY_EXECUTABLE)
endif

pypy-c:
	@echo
	@echo "===================================================================="
ifeq ($(PYPY_EXECUTABLE),)
	@echo "Building a regular (jitting) version of PyPy, using CPython."
	@echo "This takes around 2 hours and $(URAM) GB of RAM."
	@echo "Note that pre-installing a PyPy binary would reduce this time"
	@echo "and produce basically the same result."
else
	@echo "Building a regular (jitting) version of PyPy, using"
	@echo "$(PYPY_EXECUTABLE) to run the translation itself."
	@echo "This takes up to 1 hour and $(URAM) GB of RAM."
endif
	@echo
	@echo "For more control (e.g. to use multiple CPU cores during part of"
	@echo "the process) you need to run \`\`rpython/bin/rpython'' directly."
	@echo "For more information see \`\`http://pypy.org/download.html''."
	@echo "===================================================================="
	@echo
	@sleep 5
	$(RUNINTERP) rpython/bin/rpython -Ojit pypy/goal/targetpypystandalone.py

# Note: the -jN option, or MAKEFLAGS=-jN, are not usable.  They are
# replaced with an opaque --jobserver option by the time this Makefile
# runs.  We cannot get their original value either:
# http://lists.gnu.org/archive/html/help-make/2010-08/msg00106.html

=== pypy/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  man       to make manual pages"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyPy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyPy.qhc"

latex:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

man:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man"

changes:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	# python config/generate.py #readthedocs will not run this Makefile
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== pypy/module/array/benchmark/Makefile ===
CFLAGS=-O3 -mtune=native -march=native -std=gnu99 

intimg: intimgtst.o intimg.o
	gcc -o $@ $^
loop: loop.o
	gcc -o $@ $^
sum: sumtst.o sum.o
	gcc -o $@ $^	
circular: circulartst.o circular.o
	gcc -o $@ $^	

run: run-intimg run-sum run-circular

run-%: %
	@echo $^
	@echo -n '         C: '
	@/usr/bin/time -f '%e s' ./$^ 2>&1 | tail -1
	@echo -n '      pypy: '
	@/usr/bin/time -f '%e s' ../../../translator/goal/pypy-c $^tst.py 2>&1 | tail -1
	@echo -n 'pypy-trunk: '
	@/usr/bin/time -f '%e s' ../../../../../trunk/pypy/translator/goal/pypy-c $^tst.py 2>&1 | tail -1
	@echo -n '   cpython: '
	@/usr/bin/time -f '%e s' python $^tst.py 2>&1 | tail -1
	@echo

=== pypy/module/cppyy/test/Makefile ===
dicts = example01Dict.so datatypesDict.so advancedcppDict.so advancedcpp2Dict.so \
overloadsDict.so stltypesDict.so operatorsDict.so fragileDict.so crossingDict.so \
std_streamsDict.so iotypesDict.so
all : $(dicts)

ifneq (${REFLEXHOME},)
  ROOTSYS := ${REFLEXHOME}
else
  ROOTSYS := ${ROOTSYS}
endif

ifeq ($(ROOTSYS),)
  genreflex=genreflex
  cppflags=-I$(shell root-config --incdir) -L$(shell root-config --libdir)
else
  genreflex=$(ROOTSYS)/bin/genreflex
  ifeq ($(wildcard $(ROOTSYS)/include),)     # standard locations used?
    cppflags=-I$(shell root-config --incdir) -L$(shell root-config --libdir)
  else
    cppflags=-I$(ROOTSYS)/include -L$(ROOTSYS)/lib64 -L$(ROOTSYS)/lib
  endif
endif

PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
  cppflags+=-dynamiclib -single_module -arch x86_64 -undefined dynamic_lookup
endif

ifeq ($(CINT),)
  ifeq ($(shell $(genreflex) --help | grep -- --with-methptrgetter),)
    genreflexflags=
    cppflags2=-O3 -fPIC
  else
    genreflexflags=--with-methptrgetter
    cppflags2=-Wno-pmf-conversions -O3 -fPIC
  endif
else
  cppflags2=-O3 -fPIC -rdynamic
endif

ifeq ($(CINT),)
%Dict.so: %_rflx.cpp %.cxx
	echo $(cppflags)
	g++ -o $@ $^ -shared -lReflex $(cppflags) $(cppflags2)

%_rflx.cpp: %.h %.xml
	$(genreflex) $< $(genreflexflags) --selection=$*.xml --rootmap=$*Dict.rootmap --rootmap-lib=$*Dict.so
else
%Dict.so: %_cint.cxx %.cxx
	g++ -o $@ $^ -shared $(cppflags) $(cppflags2)
	rlibmap -f -o $*Dict.rootmap -l $@ -c $*_LinkDef.h

%_cint.cxx: %.h %_LinkDef.h
	rootcint -f $@ -c $*.h $*_LinkDef.h
endif

ifeq ($(CINT),)
# TODO: methptrgetter causes these tests to crash, so don't use it for now
std_streamsDict.so: std_streams.cxx std_streams.h std_streams.xml
	$(genreflex) std_streams.h --selection=std_streams.xml
	g++ -o $@ std_streams_rflx.cpp std_streams.cxx -shared -lReflex $(cppflags) $(cppflags2)
endif

.PHONY: clean
clean:
	-rm -f $(dicts) $(subst .so,.rootmap,$(dicts)) $(wildcard *_cint.h)

=== debian/changelog ===
pypy (2.2.1+dfsg-1ubuntu0.3) trusty-proposed; urgency=medium

  * SRU: LP: #1499957.
  * Fix build with updated GCC.
    https://bitbucket.org/pypy/pypy/commits/c1abec418acf30bb04891c3249bc12cbe8f48d4a

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Sep 2015 20:35:21 +0200

pypy (2.2.1+dfsg-1ubuntu0.2) trusty; urgency=medium

  * fpic-ppc: Compile with -fPIC on PPC, to avoid an FTBFS.

 -- Stefano Rivera <stefanor@ubuntu.com>  Tue, 02 Dec 2014 14:33:18 -0800

pypy (2.2.1+dfsg-1ubuntu0.1) trusty; urgency=medium

  * Cherry-pick a patch (jit-crash-1669) to fix a JIT crash. (LP: #1368418)

 -- Stefano Rivera <stefanor@ubuntu.com>  Fri, 28 Nov 2014 18:34:13 -0800

pypy (2.2.1+dfsg-1) unstable; urgency=low

  * New upstream bugfix release.
    - Fixes a ref-counting bug in socket.
  * Drop build-dep on execstack. Doesn't appear to be necessary any more (and
    doesn't work on all achitectures).

 -- Stefano Rivera <stefanor@debian.org>  Wed, 27 Nov 2013 11:41:10 -0800

pypy (2.2.0+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches.
  * Add new upstream copyright holders to debian/copyright.
  * Drop test_bootstrap-path patch, applied upstream.
  * pypy{clean,compile}: Perform a logical and instead of or, when -p and a
    directory are specified (matching pycompile semantics).
  * Disable JIT on armel. ARMv5 isn't supported.
  * Drop build-dep on valgrind on armel. It's no longer a supported platform
    for valgrind (Closes: #729141).
  * Bump debian/compat to 9, for executable dh_install scripts.
  * Split the stdlib test suite into a new binary package: pypy-lib-testsuite.
  * Split the _tkinter module into a new binary package: pypy-tk.
  * Run pypyclean on the stdlib before upgrading.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 16 Nov 2013 23:05:19 +0000

pypy (2.1.0+dfsg-3) unstable; urgency=low

  * The wildcard for ARM is any-arm.
  * Build the syslog cffi module in lib_pypy.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 12 Sep 2013 10:33:55 +0200

pypy (2.1.0+dfsg-2) unstable; urgency=low

  * Disable continuation on all architectures except x86 and ARM (requires
    porting).

 -- Stefano Rivera <stefanor@debian.org>  Tue, 10 Sep 2013 17:10:34 +0200

pypy (2.1.0+dfsg-1) unstable; urgency=low

  * New upstream release.
    - The ARM JIT is now supported and enabled.
    - Several bug fixes and performance improvements.
  * Refresh patches.
  * Drop patches, applied/superseded upstream:
    - shared-ffi
    - distutils-cflags
    - gnukfreebsd
    - l2-cache-detection
  * Add pypycompile and pypyclean scripts for dh_pypy packages.
    - Use for byte-compiling the stdlib.
  * Build cffi module for tkinter.
  * Patch: test_bootstrap-path - avoid a spurious test failure when TMPDIR is
    set to inside the source tree.
  * Add /usr/lib/pypy/runtime.d, so that module re-byte-compilation can be
    triggered on minor version updates. As we only have one pypy version
    installed concurrently, only .rtupdate is supported.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 01 Sep 2013 09:35:58 +0200

=== debian/control ===
Source: pypy
Section: python
Priority: extra
Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper (>= 9),
 libbz2-dev,
 libexpat1-dev,
 libffi-dev,
 libncurses-dev,
 libsqlite3-dev,
 libssl-dev,
 netbase,
 pkg-config,
 procps,
 python (>= 2.6.6-11~),
 python-docutils,
 python-sphinx (>= 1.0.7+dfsg),
 python2.7-dev,
 tcl-dev,
 tk-dev,
 valgrind [amd64 armhf i386 mips mipsel powerpc ppc64 s390x],
 zlib1g-dev
Build-Depends-Indep: graphviz
Standards-Version: 3.9.4
Homepage: http://pypy.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git

Package: pypy
Architecture: kfreebsd-any linux-any
Depends: pypy-lib (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: pypy-dev (<< ${source:Version})
Suggests: pypy-doc, pypy-tk (= ${binary:Version})
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: fast alternative implementation of Python - PyPy interpreter
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7). It has several advantages and distinct features:
  * Speed: thanks to its Just-in-Time compiler (on x86), Python programs often
    run faster on PyPy.
  * Memory usage: large, memory-hungry Python programs might end up taking less
    space than they do in CPython.
  * Compatibility: PyPy is highly compatible with existing Python code.
    It supports ctypes and can run popular Python libraries like twisted and
    django.
  * Stackless: PyPy supports stackless mode on x86, providing
    micro-threads for massive concurrency.
 .
 This package contains the PyPy interpreter.

Package: pypy-tk
Architecture: kfreebsd-any linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, pypy (= ${binary:Version})
Replaces: pypy-lib (<< 2.2)
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: Tkinter module for PyPy (an alternative Python interpreter)
 A module for writing portable GUI applications with PyPy using Tk.
 Also known as Tkinter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: python-pypy.sandbox
Architecture: kfreebsd-any linux-any
Depends:
 pypy-lib (= ${source:Version}),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Suggests: python-py
Replaces: python-pypy.translator.sandbox (<< 2.0~beta2+hg61648)
Breaks: python-pypy.translator.sandbox (<< 2.0~beta2+hg61648)
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: sandboxed PyPy interpreter
 A version of PyPy that runs fully "virtualized", where an external process
 controls all input/output. This is a secure sandbox, it is safe to run any
 untrusted Python code with it. The Python code cannot see or modify any local
 file except via interaction with the external process.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-lib
Architecture: all
Depends: ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Provides: pypy-cffi
Description: standard library for PyPy (an alternative Python interpreter)
 The PyPy standard library. This is a combination of modules, copied directly
 from cpython, modified cpython modules, and modules entirely re-implemented
 (usually in pure Python, where they are C extensions in cpython).
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-lib-testsuite
Architecture: all
Depends: pypy-lib (= ${source:Version}), ${misc:Depends}
Replaces: pypy-lib (<< 2.2)
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: standard library test suite for PyPy (an alternative Python interpreter)
 The complete test suite for the PyPy standard library.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Suggests: python-doc
Description: developer Documentation for PyPy (an alternative Python interpreter)
 The Developer documentation for PyPy. This mostly covers the internals of
 PyPy, and development of PyPy itself.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

Package: pypy-dev
Architecture: all
Depends: pypy (>= ${source:Version}), ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: header files for PyPy (an alternative Python interpreter)
 Header files for compiling cpython C extension modules for use with PyPy.
 Note that pure Python modules will probably perform better.
 .
 PyPy supports a subset of cpython's C API through its CPyExt subsystem.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (2.7).

## pypy 2.3.1+dfsg

=== debian/changelog ===
pypy (2.3.1+dfsg-1) unstable; urgency=medium

  * New upstream point release.
    - Includes gdbm module.
      + Build-Depend on libgdbm-dev.
  * Refresh patches.
  * Drop patches, superseded upstream: _struct, gcc-4.9, unknown-cpu.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 10 Jun 2014 02:07:03 +0200

pypy (2.3+dfsg-3) unstable; urgency=medium

  * And similarly, avoid an assertion about VFP support, in an ARM specific
    path, in the same function, fixing an FTBFS on armel.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 27 May 2014 01:55:01 +0200

pypy (2.3+dfsg-2) unstable; urgency=medium

  * Patch unknown-cpu: Fix an FTBFS on archs which don't have JIT support, due
    to the use of a previously JIT-specific CPU detection function.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 25 May 2014 22:51:01 +0200

pypy (2.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patches, superseded upstream: fpic-ppc, multiprocessing-typos,
    site-builddir, webbrowser, pypirc-secure.
  * PyPy.h isn't copied in at build time (unlike all the other headers)
  * Patch: _struct - Like CPython, the built-in module should be "_struct",
    imported.
  * Patch: gcc-4.9 - Build on GCC 4.9 (Closes: #746892)
  * Patch: sqlite-3.8.4 - Test suite fix for 3.8.4 compatibility.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 25 May 2014 16:51:43 +0200

pypy (2.2.1+dfsg-3) unstable; urgency=medium

  * fpic-ppc: Compile with -fPIC on PPC.
  * Put exits in the right places in the maintainer scripts (Closes: #747177)

 -- Stefano Rivera <stefanor@debian.org>  Tue, 06 May 2014 12:00:44 +0200

pypy (2.2.1+dfsg-2) unstable; urgency=medium

  * pep3147-stdlib: In compileall, only create __pycache__ directories when
    we've found a .py file. (Closes: #742132)
  * Bump Standards-Version to 3.9.5, no changes needed.
  * Abort in postinst if PyPy won't run on the machine's CPU. Unfortunately,
    the non-SSE2 build is currently broken. (Closes: #737018)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 04 May 2014 23:57:47 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  libbz2-dev,
  libexpat1-dev,
  libffi-dev,
+ libgdbm-dev,
  libncurses-dev,
  libsqlite3-dev,
  libssl-dev,
@@ -22,7 +23,7 @@
  valgrind [amd64 armhf i386 mips mipsel powerpc ppc64 s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://pypy.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 override_dh_auto_build-arch: pypy/goal/pypy-c pypy/goal/pypy-c-sandbox
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 	# Build cffi modules
-	pypy/goal/pypy-c -c 'import _sqlite3, _curses, _tkinter.tklib, syslog'
+	pypy/goal/pypy-c -c 'import _sqlite3, _curses, _tkinter.tklib, gdbm, syslog'
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
@@ -91,9 +91,10 @@
 	dh_python2 -p python-pypy.sandbox
 
 override_dh_installdeb:
-	set -e; for maintscript in preinst postinst; do \
-		sed 's/#VERSION#/$(VER)/g' debian/pypy.$$maintscript.in \
-		    > debian/pypy.$$maintscript; \
+	set -e; for maintscript in preinst postinst prerm; do \
+		sed -e 's/#VERSION#/$(VER)/g' \
+		    -e 's/#ARCH#/$(shell dpkg-architecture -qDEB_HOST_ARCH)/g' \
+		    debian/pypy.$$maintscript.in > debian/pypy.$$maintscript; \
 	done
 	dh_installdeb

## pypy 2.4.0+dfsg

=== pypy/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PyPy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PyPy.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/PyPy"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/PyPy"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== pypy/module/cppyy/test/Makefile ===
dicts = example01Dict.so datatypesDict.so advancedcppDict.so advancedcpp2Dict.so \
overloadsDict.so stltypesDict.so operatorsDict.so fragileDict.so crossingDict.so \
std_streamsDict.so iotypesDict.so
all : $(dicts)

ifneq (${REFLEXHOME},)
  ROOTSYS := ${REFLEXHOME}
else ifneq (${ROOTSYS},)
  ROOTSYS := ${ROOTSYS}
else
  DUMMY := t
endif

ifeq ($(DUMMY),t)
  cppflags=
else
  ifeq ($(ROOTSYS),)
    genreflex=genreflex
    cppflags=-I$(ROOTSYS)/include -L$(ROOTSYS)/lib64 -L$(ROOTSYS)/lib
  else
    genreflex=$(ROOTSYS)/bin/genreflex
    ifeq ($(wildcard $(ROOTSYS)/include),)       # standard locations used?
      cppflags=-I$(shell root-config --incdir) -L$(shell root-config --libdir)
    else
      cppflags=-I$(ROOTSYS)/include -L$(ROOTSYS)/lib64 -L$(ROOTSYS)/lib
    endif
  endif
endif

PLATFORM := $(shell uname -s)
ifeq ($(PLATFORM),Darwin)
  cppflags+=-dynamiclib -single_module -arch x86_64 -undefined dynamic_lookup
endif

ifeq ($(DUMMY),t)
  cppflags2=-O3 -fPIC -rdynamic
else ifeq ($(CINT),t)
  cppflags2=-O3 -fPIC -rdynamic
else
  ifeq ($(shell $(genreflex) --help | grep -- --with-methptrgetter),)
    genreflexflags=
    cppflags2=-O3 -fPIC
  else
    genreflexflags=--with-methptrgetter
    cppflags2=-Wno-pmf-conversions -O3 -fPIC
  endif
endif

ifeq ($(CINT),t)
%Dict.so: %_cint.cxx %.cxx
	g++ -o $@ $^ -shared $(cppflags) $(cppflags2)
	rlibmap -f -o $*Dict.rootmap -l $@ -c $*_LinkDef.h

%_cint.cxx: %.h %_LinkDef.h
	rootcint -f $@ -c $*.h $*_LinkDef.h

else ifeq ($(DUMMY),t)
%Dict.so: %.cxx
	g++ -o $@ $^ -shared $(cppflags) $(cppflags2)

else # reflex
%Dict.so: %_rflx.cpp %.cxx
	g++ -o $@ $^ -shared -lReflex $(cppflags) $(cppflags2)

%_rflx.cpp: %.h %.xml
	$(genreflex) $< $(genreflexflags) --selection=$*.xml --rootmap=$*Dict.rootmap --rootmap-lib=$*Dict.so

endif

ifeq ($(CINT),)
ifeq ($(DUMMY),)
# TODO: methptrgetter causes these tests to crash, so don't use it for now
std_streamsDict.so: std_streams.cxx std_streams.h std_streams.xml
	$(genreflex) std_streams.h --selection=std_streams.xml
	g++ -o $@ std_streams_rflx.cpp std_streams.cxx -shared -lReflex $(cppflags) $(cppflags2)
endif
endif

.PHONY: clean
clean:
	-rm -f $(dicts) $(subst .so,.rootmap,$(dicts)) $(wildcard *_cint.h)

=== debian/changelog ===
pypy (2.4.0+dfsg-3) unstable; urgency=medium

  * Switch to noawait triggers on /usr/lib/pypy/lib-python. Byte-compilation
    isn't critical (Closes: #772863).

 -- Stefano Rivera <stefanor@debian.org>  Sat, 20 Dec 2014 12:44:38 +0200

pypy (2.4.0+dfsg-2) unstable; urgency=medium

  * Patch trackgcroot-new-ops: Fix FTBFS with gcc 4.9.2, expect some new
    operations. (Closes: #771137)
  * Cherry-pick upstream patches for:
    - ast-segfault: an AST compiler crash.
    - io-double-rewind: EINVAL in raw io.
    - streamio-ext-seek: Avoid an crash when fds are unexpectedly seeked.
    - ndarray-swapaxes-segfault: Description: Fix a segfault when doing a noop
      swapaxes.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 26 Nov 2014 22:51:30 -0800

pypy (2.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright.
  * Refresh patches.
  * Drop patches, superseded upstream: so_reuseport, sqlite-3.8.4.
  * Patch fpic-archs: hppa and x32 require -fPIC (Closes: #760267).
  * Don't attempt to build a JIT on x32.
  * Patch: sandbox-access: Implement os.access, to get the sandbox working in
    2.4.0.
  * Update kFreeBSD releases in patch plat-gnukfreebsd.
  * Clean up local variables in patch plat-linux2-differences.
  * Add lintian overrides for pypy-lib-testsuite, that were missed in the
    stdlib break-up.
  * First multi-arch steps:
    - Patch: multiarch: Add multiarch tag to C extension file names.
    - Build-Depend on dh-exec, to ease installing to multiarch paths.
    - Move pypy-c-sandbox to a multiarch path.
    - Fully qualify (cffi) extension filenames with multiarch tags.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 24 Sep 2014 00:51:03 -0700

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper (>= 9),
+ dh-exec,
  libbz2-dev,
  libexpat1-dev,
  libffi-dev,

=== debian/rules ===
--- 
+++ 
@@ -25,8 +25,10 @@
 
 override_dh_auto_build-arch: pypy/goal/pypy-c pypy/goal/pypy-c-sandbox
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
+
 	# Build cffi modules
 	pypy/goal/pypy-c -c 'import _sqlite3, _curses, _tkinter.tklib, gdbm, syslog'
+	debian/scripts/multiarch-extensions.sh
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

## pypy 2.5.0+dfsg

=== debian/changelog ===
pypy (2.5.0+dfsg-2) experimental; urgency=medium

  * Add a Depends: pypy to pypy-lib-testsuite - it uses pypycompile on
    install, now. (Closes: #777641)
  * Patch no-shared-export-symbols: Export symbols required by C extensions,
    again.
  * Patch skip-test_multiprocessing: Disable test_multiprocessing, it leaves
    stray processes on buildds (and generally seems buggy).

 -- Stefano Rivera <stefanor@debian.org>  Wed, 11 Feb 2015 13:36:11 -0800

pypy (2.5.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Upload to experimental (due to jessie freeze).
  * Drop patches, superseded upstream: sandbox-access, trackgcroot-new-ops,
    ast-segfault, io-double-rewind, streamio-ext-seek,
    ndarray-swapaxes-segfault.
  * Update copyright.
  * Remove buildd RAM check, most buildds are now sufficiently capable, or
    pypy has been blacklisted on them. (Closes: #730216)
  * Adjust multiarch patch to build gracefully under a non-multiarch Python.
  * Rejig maintainer scripts. All byte-compilation now happens in the pypy
    binary package, without triggers.
  * Bump Standards-Version to 3.9.6, no changes needed.
  * Build with --no-shared for now. Upstream now builds a shared library by
    default, but we aren't ready for it.
  * Use valgrind headers on arm64 and ppc64el, they both now support it.
  * Patch no-ssl3: Allow testing without SSLv3 support.
  * Patch test_jit-ffi: Fix a test failure in the JIT.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 09 Feb 2015 11:13:52 -0800

=== debian/control ===
--- 
+++ 
@@ -21,10 +21,10 @@
  python2.7-dev,
  tcl-dev,
  tk-dev,
- valgrind [amd64 armhf i386 mips mipsel powerpc ppc64 s390x],
+ valgrind [arm64 amd64 armhf i386 mips mipsel powerpc ppc64 ppc64el s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://pypy.org/
 Vcs-Git: git://anonscm.debian.org/collab-maint/pypy.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/pypy.git
@@ -52,7 +52,7 @@
 
 Package: pypy-tk
 Architecture: kfreebsd-any linux-any
-Depends: ${misc:Depends}, ${shlibs:Depends}, pypy (= ${binary:Version})
+Depends: pypy (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Replaces: pypy-lib (<< 2.2)
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: Tkinter module for PyPy (an alternative Python interpreter)
@@ -97,7 +97,7 @@
 
 Package: pypy-lib-testsuite
 Architecture: all
-Depends: pypy-lib (= ${source:Version}), ${misc:Depends}
+Depends: pypy, pypy-lib (= ${source:Version}), ${misc:Depends}
 Replaces: pypy-lib (<< 2.2)
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: standard library test suite for PyPy (an alternative Python interpreter)

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 	dh $@ --with python2,sphinxdoc
 
 override_dh_auto_configure:
-	debian/scripts/memory-check.sh
+	# This rule left intentionally empty
 
 override_dh_auto_build-arch: pypy/goal/pypy-c pypy/goal/pypy-c-sandbox
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs

## pypy 2.6.0+dfsg

=== debian/changelog ===
pypy (2.6.0+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * Use the correct (pypy) marshal module, in the sandbox. (Closes: #785559)
  * Install ansiramp in the sandbox, to fix --verbose on 256 colour terminals.
    (Closes: #785554)

 -- Stefano Rivera <stefanor@debian.org>  Fri, 03 Jul 2015 13:43:58 -0700

pypy (2.6.0+dfsg-2) experimental; urgency=medium

  * libunwind is only available on Linux amd64.
  * Patch hg-updates: Pull bugfixes from the upstream 2.6 maintenance branch.
  * Patch vmprof-amd64: vmprof uses x86_64 assembler, so it's only available
    on x86_64.
  * Patch ensure-valid-term: Squash some readline related test failures.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 14 Jun 2015 18:05:35 -0700

pypy (2.6.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update copyright.
  * cffi modules are now explicitly built, use the function in upstream's
    package tool to do this.
  * Build-Depends and Recommend: libunwind-dev, for vmprof on any-amd64 only.
    (With alternative B-Ds for building on older releases)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 07 Jun 2015 21:00:34 -0700

pypy (2.5.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
    + Drop ensurepip eggs from source tarball.
  * Refresh patches.
  * Drop patches, superseded upstream: test_jit-ffi, no-shared-export-symbols,
    and no-ssl3.
  * Build new CFFI module: audioop.
  * Apply ensurepip-wheels and ensurepip-disabled from the python2.7 package.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 27 Mar 2015 08:31:36 -0700

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  libncurses-dev,
  libsqlite3-dev,
  libssl-dev,
+ libunwind-dev [amd64] | libunwind8-dev [amd64] | libunwind7-dev [amd64],
  netbase,
  pkg-config,
  procps,
@@ -34,6 +35,7 @@
 Depends: pypy-lib (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
 Breaks: pypy-dev (<< ${source:Version})
 Suggests: pypy-doc, pypy-tk (= ${binary:Version})
+Recommends: ${pypy:Recommends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: fast alternative implementation of Python - PyPy interpreter
  PyPy is a fast, compliant alternative implementation of the Python language

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 	# Build cffi modules
-	pypy/goal/pypy-c -c 'import _sqlite3, _curses, _tkinter.tklib, gdbm, syslog'
+	debian/scripts/build-cffi-modules.py
 	debian/scripts/multiarch-extensions.sh
 
 override_dh_auto_build-indep:
@@ -100,6 +100,9 @@
 	done
 	dh_installdeb
 
+override_dh_gencontrol:
+	dh_gencontrol -- $(shell dpkg-query -f '-Vpypy:Recommends=$${Package} $${Status}\n' --show 'libunwind*-dev' | grep ' installed$$' | cut -d' ' -f 1)
+
 override_dh_builddeb:
 	dh_builddeb -- -Zxz
 
@@ -116,7 +119,8 @@
 	cd pypy-$(VER).orig && hg up -r $(REV)
 endif
 	rm -rf pypy-$(VER).orig/.hg*
-	rm pypy-$(VER).orig/lib-python/*2.7/distutils/command/*.exe
+	rm pypy-$(VER).orig/lib-python/2.7/distutils/command/*.exe
+	rm -rf pypy-$(VER).orig/lib-python/2.7/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
 	    -f pypy_$(VER)+dfsg.orig.tar.xz pypy-$(VER).orig
 	rm -rf pypy-$(VER).orig
